%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Text = PCL_MPC_Modify_RBE3(MPC_ID, Ind_Data, Dep_Node, Dep_DOFs)

Compact_Ind_Data = cell(size(Ind_Data,1), 1);

counter = 1;
Compact_Ind_Data_counter = 1;

Compact_Ind_Data{Compact_Ind_Data_counter}.weight = Ind_Data(counter,1);
Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list = zeros(50000,1);
Ind_Grid_local_counter = 1;
Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list(Ind_Grid_local_counter) = Ind_Data(counter,2);
Compact_Ind_Data{Compact_Ind_Data_counter}.ind_DOF = Ind_Data(counter,3);

while(1)
    
    if (counter == size(Ind_Data,1))
        
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list = Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list(1:Ind_Grid_local_counter);
        Compact_Ind_Data = Compact_Ind_Data(1:Compact_Ind_Data_counter);
        
        break;
        
    end
    
    counter = counter + 1;
    
    if ((Ind_Data(counter,1) == Compact_Ind_Data{Compact_Ind_Data_counter}.weight) && (Ind_Data(counter,3) == Compact_Ind_Data{Compact_Ind_Data_counter}.ind_DOF))
        
        Ind_Grid_local_counter = Ind_Grid_local_counter + 1;
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list(Ind_Grid_local_counter) = Ind_Data(counter,2);
        
    else
        
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list = Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list(1:Ind_Grid_local_counter);
        
        Compact_Ind_Data_counter = Compact_Ind_Data_counter + 1;
        
        Compact_Ind_Data{Compact_Ind_Data_counter}.weight = Ind_Data(counter,1);
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list = zeros(50000,1);
        Ind_Grid_local_counter = 1;
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_grid_list(Ind_Grid_local_counter) = Ind_Data(counter,2);
        Compact_Ind_Data{Compact_Ind_Data_counter}.ind_DOF = Ind_Data(counter,3);
        
    end
    
end

N_terms = 1 + Compact_Ind_Data_counter;

Text = cell(1,1);

dependency_flag_string = 'TRUE';

for i=1:N_terms-1
    dependency_flag_string = [dependency_flag_string ', FALSE']; %#ok<AGROW>
end

coefficient_string = '"0."';

for i=1:N_terms-1
    coefficient_string = [coefficient_string sprintf(', "%.10f"', Compact_Ind_Data{i}.weight)]; %#ok<AGROW>
end

node_select_string = sprintf('"Node %i"', Dep_Node);

for i=1:N_terms-1
    node_substring = ['"Node' sprintf(' %i', Compact_Ind_Data{i}.ind_grid_list) '"'];
    node_select_string = [node_select_string ', ' node_substring]; %#ok<AGROW>
end

Dep_DOFs_char = num2str(Dep_DOFs);

Dep_DOFs_string = [];

switch Dep_DOFs_char(1)
    case '1'
        Dep_DOFs_string = 'UX';
    case '2'
        Dep_DOFs_string = 'UY';
    case '3'
        Dep_DOFs_string = 'UZ';
    case '4'
        Dep_DOFs_string = 'RX';
    case '5'
        Dep_DOFs_string = 'RY';
    case '6'
        Dep_DOFs_string = 'RZ';
end

for i=2:numel(Dep_DOFs_char)
    
    switch Dep_DOFs_char(i)
        case '1'
            Dep_DOFs_string = [Dep_DOFs_string ',UX']; %#ok<AGROW>
        case '2'
            Dep_DOFs_string = [Dep_DOFs_string ',UY']; %#ok<AGROW>
        case '3'
            Dep_DOFs_string = [Dep_DOFs_string ',UZ']; %#ok<AGROW>
        case '4'
            Dep_DOFs_string = [Dep_DOFs_string ',RX']; %#ok<AGROW>
        case '5'
            Dep_DOFs_string = [Dep_DOFs_string ',RY']; %#ok<AGROW>
        case '6'
            Dep_DOFs_string = [Dep_DOFs_string ',RZ']; %#ok<AGROW>
    end
    
end

degrees_of_freedom_string = ['"' Dep_DOFs_string '"'];

for i=1:N_terms-1
    
    Ind_DOFs_char = num2str(Compact_Ind_Data{i}.ind_DOF);

    Ind_DOFs_string = [];

    switch Ind_DOFs_char(1)
        case '1'
            Ind_DOFs_string = 'UX';
        case '2'
            Ind_DOFs_string = 'UY';
        case '3'
            Ind_DOFs_string = 'UZ';
        case '4'
            Ind_DOFs_string = 'RX';
        case '5'
            Ind_DOFs_string = 'RY';
        case '6'
            Ind_DOFs_string = 'RZ';
    end

    for j=2:numel(Ind_DOFs_char)

        switch Ind_DOFs_char(j)
            case '1'
                Ind_DOFs_string = [Ind_DOFs_string ',UX']; %#ok<AGROW>
            case '2'
                Ind_DOFs_string = [Ind_DOFs_string ',UY']; %#ok<AGROW>
            case '3'
                Ind_DOFs_string = [Ind_DOFs_string ',UZ']; %#ok<AGROW>
            case '4'
                Ind_DOFs_string = [Ind_DOFs_string ',RX']; %#ok<AGROW>
            case '5'
                Ind_DOFs_string = [Ind_DOFs_string ',RY']; %#ok<AGROW>
            case '6'
                Ind_DOFs_string = [Ind_DOFs_string ',RZ']; %#ok<AGROW>
        end

    end
    
    degrees_of_freedom_string = [degrees_of_freedom_string ', "' Ind_DOFs_string '"']; %#ok<AGROW>
    
end

Text{1} = ['fem_modify_mpc_nodal2( ' sprintf('%i', MPC_ID) ', 0., ' sprintf('%i', N_terms) ', [' dependency_flag_string '], [' coefficient_string '], [' node_select_string '], [' degrees_of_freedom_string '] )'];
